import { TerminalStage } from '../../stages';
class AllMatchCollector extends TerminalStage {
    _predicate;
    _allMatch = true;
    constructor(_predicate) {
        super();
        this._predicate = _predicate;
    }
    consume(element) {
        this._allMatch = this._predicate(element);
        if (!this._allMatch) {
            this.broadcast("TERMINATE_EARLY" /* PipelineEvent.TERMINATE_EARLY */);
        }
    }
    get() {
        return this._allMatch;
    }
}
/**
 * Return a terminal stage that evaluates whether all elements in the pipeline match the provided predicate.
 *
 * @param predicate
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 *
 * @returns
 *
 */
export function allMatch(predicate) {
    return new AllMatchCollector(predicate);
}
//# sourceMappingURL=allMatch.js.map