import { TerminalStage } from '../../stages';
class AnyMatchCollector extends TerminalStage {
    _predicate;
    _anyMatch = false;
    constructor(_predicate) {
        super();
        this._predicate = _predicate;
    }
    consume(element) {
        this._anyMatch = this._predicate(element);
        if (this._anyMatch) {
            this.broadcast("TERMINATE_EARLY" /* PipelineEvent.TERMINATE_EARLY */);
        }
    }
    get() {
        return this._anyMatch;
    }
}
/**
 * Return a terminal stage that evaluates whether at least one element in the pipeline matches the provided predicate.
 *
 * @param predicate
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 *
 * @returns
 */
export function anyMatch(predicate) {
    return new AnyMatchCollector(predicate);
}
//# sourceMappingURL=anyMatch.js.map