import { TerminalStage } from '../../stages';
class FindLastCollector extends TerminalStage {
    _lastElement;
    consume(element, hasMoreUpstreamData) {
        if (!hasMoreUpstreamData) {
            this._lastElement = element;
        }
    }
    get() {
        return this._lastElement;
    }
}
/**
 * Return a terminal stage that finds and retrieves the very last element
 * in the pipeline. If no such element exists, `undefined` is returned.
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 */
export function findLast() {
    return new FindLastCollector();
}
//# sourceMappingURL=findLast.js.map