import { IntermediateStage } from '../../stages';
class DistinctStage extends IntermediateStage {
    _seenElementMap = new Map();
    consume(element, hasMoreDataUpstream) {
        if (!this._seenElementMap.has(element)) {
            this._downstream.consume(element, hasMoreDataUpstream);
            this._seenElementMap.set(element, true);
        }
    }
    reset() {
        this._seenElementMap.clear();
        super.reset();
    }
}
/**
 * Return an intermediate stage that lets only unique elements pass through.
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 *
 * @returns
 */
export function distinct() {
    return new DistinctStage();
}
//# sourceMappingURL=distinct.js.map