import { IntermediateStage } from '../../stages';
class FilterStage extends IntermediateStage {
    _predicate;
    constructor(_predicate) {
        super();
        this._predicate = _predicate;
    }
    consume(element, hasMoreDataUpstream) {
        if (this._predicate(element)) {
            this._downstream.consume(element, hasMoreDataUpstream);
        }
    }
}
/**
 * Return an intermediate stage that filters out elements that do not match the provided predicate.
 *
 * @param predicate
 *
 * @template IN The type parameter of each incoming element in the pipeline.
 *
 * @returns
 */
export function filter(predicate) {
    return new FilterStage(predicate);
}
//# sourceMappingURL=filter.js.map